/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline bool elm_interface_atspi_action::action_do(int id_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_do(id_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline char * elm_interface_atspi_action::keybinding_get(int id_) const
{
   char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_keybinding_get(id_));
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view elm_interface_atspi_action::name_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_name_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view elm_interface_atspi_action::localized_name_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_localized_name_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view elm_interface_atspi_action::description_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_description_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline bool elm_interface_atspi_action::description_set(int id_, ::efl::eina::string_view description_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_description_set(id_, ::efl::eolian::to_c(description_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::range_list< Elm_Atspi_Action > elm_interface_atspi_action::actions_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_actions_get());
   return ::efl::eolian::to_cxx<::efl::eina::range_list< Elm_Atspi_Action >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_action::action_do(int id_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_do(id_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline char * eo_cxx::elm_interface_atspi_action::keybinding_get(int id_) const
{
   char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_keybinding_get(id_));
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view eo_cxx::elm_interface_atspi_action::name_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_name_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view eo_cxx::elm_interface_atspi_action::localized_name_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_localized_name_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::string_view eo_cxx::elm_interface_atspi_action::description_get(int id_) const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_description_get(id_));
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline bool eo_cxx::elm_interface_atspi_action::description_set(int id_, ::efl::eina::string_view description_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_description_set(id_, ::efl::eolian::to_c(description_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
inline ::efl::eina::range_list< Elm_Atspi_Action > eo_cxx::elm_interface_atspi_action::actions_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_action_actions_get());
   return ::efl::eolian::to_cxx<::efl::eina::range_list< Elm_Atspi_Action >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}
#endif

inline ::eo_cxx::elm_interface_atspi_action::operator ::elm_interface_atspi_action() const
{
   return *static_cast<::elm_interface_atspi_action const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_action::operator ::elm_interface_atspi_action&()
{
   return *static_cast<::elm_interface_atspi_action*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_action::operator ::elm_interface_atspi_action const&() const
{
   return *static_cast<::elm_interface_atspi_action const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_action_action_do_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_)
{
   try
      {
         return static_cast<T*>(self->this_)->action_do(id_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
char * _elm_interface_atspi_action_keybinding_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_)
{
   try
      {
         return static_cast<T*>(self->this_)->keybinding_get(id_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         char * _tmp_ret{};
         return _tmp_ret;
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
::efl::eina::string_view _elm_interface_atspi_action_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_)
{
   try
      {
         return static_cast<T*>(self->this_)->name_get(id_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
::efl::eina::string_view _elm_interface_atspi_action_localized_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_)
{
   try
      {
         return static_cast<T*>(self->this_)->localized_name_get(id_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
::efl::eina::string_view _elm_interface_atspi_action_description_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_)
{
   try
      {
         return static_cast<T*>(self->this_)->description_get(id_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
bool _elm_interface_atspi_action_description_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int id_, const char * description_)
{
   try
      {
         return static_cast<T*>(self->this_)->description_set(id_, ::efl::eolian::to_cxx<::efl::eina::string_view>(description_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
template <typename T>
::efl::eina::range_list< Elm_Atspi_Action > _elm_interface_atspi_action_actions_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->actions_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::range_list< Elm_Atspi_Action >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_action >
{
   template <typename T>
   struct type
   {
#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual bool action_do(int id_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_do(id_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual char * keybinding_get(int id_)
      {
         char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_keybinding_get(id_));
            return _tmp_ret;
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual ::efl::eina::string_view name_get(int id_)
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_name_get(id_));
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual ::efl::eina::string_view localized_name_get(int id_)
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_localized_name_get(id_));
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual ::efl::eina::string_view description_get(int id_)
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_description_get(id_));
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual bool description_set(int id_, ::efl::eina::string_view description_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_description_set(id_, ::efl::eolian::to_c(description_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
      virtual ::efl::eina::range_list< Elm_Atspi_Action > actions_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_action_actions_get());
            return ::efl::eolian::to_cxx<::efl::eina::range_list< Elm_Atspi_Action >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_action >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_ACTION_PROTECTED) && defined(ELM_INTERFACE_ATSPI_ACTION_BETA)
      7
#elif defined(ELM_INTERFACE_ATSPI_ACTION_PROTECTED)
      7
#elif defined(ELM_INTERFACE_ATSPI_ACTION_BETA)
      0
#else
      0
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_action>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_action_do_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_do);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_keybinding_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_keybinding_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_localized_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_localized_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_description_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_description_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_description_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_description_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_action_actions_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_action_actions_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_action>)
{
   return (ELM_INTERFACE_ATSPI_ACTION_MIXIN);
}

} } }

/// @endcond

